﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;

using ToolBoxes;

namespace miniserrefinal
{
    public partial class Program
    {
        // Modes de fonctionnement (1)
            enum etats { Attendre, Tester, Superviser }; // A compléter

        public static void Main()
        {
            // Constantes
            const UInt16 delayScrut = 100; // Le clavier est lu toutes les 100ms

            // Variables (2)
            var etat = etats.Attendre;
            var etat_1 = etats.Tester;

            // Configuration des Ports d'entrées, sorties  
            // Entrées analogiques
            // http://msdn.microsoft.com/en-us/library/hh421132.aspx (Description de la classe AnalogInput)
            AnalogInput Thermometre = new AnalogInput(Cpu.AnalogChannel.ANALOG_5); // Thermomètre sur I5 Tinkerkit 
            AnalogInput CaptHum = new AnalogInput(Cpu.AnalogChannel.ANALOG_4); // Capteur humidité sur I4 Tinkerkit
            // Entrées TOR (Clavier)
            InputPort BTNO = new InputPort(Pins.GPIO_PIN_A0, false, Port.ResistorMode.Disabled);
            InputPort BTN1 = new InputPort(Pins.GPIO_PIN_A1, false, Port.ResistorMode.Disabled);
            InputPort BTN2 = new InputPort(Pins.GPIO_PIN_A2, false, Port.ResistorMode.Disabled);
            InputPort BTN3 = new InputPort(Pins.GPIO_PIN_A3, false, Port.ResistorMode.Disabled);
            // A compléter

            // Sorties
            PWM Alarme = new PWM(PWMChannels.PWM_PIN_D5, 2000, 0.5, false); // Buzzer sur O4 Tinkerkit
            OutputPort CdeChauffage = new OutputPort(Pins.GPIO_PIN_D6, false); // Chauffage sur O3 Tinkerkit
            OutputPort CdeVentilation = new OutputPort(Pins.GPIO_PIN_D11, false); // Ventilation sur O0 Tinkerkit 
            ELCD162 Lcd = new ELCD162(); // Afficheur sur O5 Tinkerkit http://webge.github.io/ELCD162/ (Description de la classe ELCD162)

            Lcd.Init(); Lcd.ClearScreen(); Lcd.CursorOff();

            while (true)
            {
                // (3) A compléter
                switch (etat)
                {
                    case etats.Attendre: 
                        Lcd.ClearScreen(); Lcd.PutString("BTN2>Tester"); Lcd.SetCursor(0, 1); Lcd.PutString("BTN3>Superviser");
                        CdeChauffage.Write(false); CdeVentilation.Write(false); Alarme.Stop();
                        if (BTN2.Read()) etat = etats.Tester;
                            else if (BTN3.Read()) etat = etats.Superviser;
                        break;
                    case etats.Tester: 
                        Lcd.ClearScreen(); Lcd.PutString("Tester"); Lcd.SetCursor(0, 1); Lcd.PutString("1>R 2>V 3>C 0>A");
                        if (BTN1.Read()) etat = etats.Attendre; 
                            else 
                            {
                                if (BTN2.Read()) CdeVentilation.Write(true); else CdeVentilation.Write(false);
                                if (BTN3.Read()) CdeChauffage.Write(true); else CdeChauffage.Write(false);
                                if (BTNO.Read()) Alarme.Start(); else Alarme.Stop();
                            }
                        break;
                    case etats.Superviser:
                        Program.Supervision(ref etat_1, ref etat, Thermometre, CaptHum, BTN1, Alarme, CdeChauffage, CdeVentilation, Lcd);
                        break;

                    default: etat = etats.Attendre;
                        break;
                }
                Thread.Sleep(delayScrut); // Scrutation du clavier
            }

        }

    }
}
